/*

	MosaicWindow.h

	© 2000, Frank Olivier, All Rights Reserved.
	© 2000, Georges-Edouard Berenger, All Rights Reserved.

*/

#ifndef _MOSAIC_WINDOW_H_
#define _MOSAIC_WINDOW_H_

#include <Window.h>

class View;

class MosaicWindow : public BWindow
{
public:
	MosaicWindow();
	virtual void	MessageReceived(BMessage * msg);	
	virtual bool	QuitRequested();
	virtual	void	MenusBeginning();
	
	View * 			view;
	bool			monitoringPossible;
	bool			monitoring;

private:
	void			SetSourceImage(BMessage * msg, bool source_only = true);
	void			SetOutputImage(BMessage * msg);
	
	void			Menu_File_Save(bool newfile);

	void			RedoSizes();

	BMenuItem *		menuitem_view_open;
	BMenuItem *		menuitem_view_reload_source;
	BMenuItem *		menuitem_view_continue;
	BMenuItem *		menuitem_view_reload_output;

	BMenuItem *		menuitem_view_start;
	BMenuItem *		menuitem_view_stop;

	BMenuItem *		menuitem_view_save;
	BMenuItem *		menuitem_view_save_as;

	BMenuItem *		menuitem_view_source;
	BMenuItem *		menuitem_view_output;

	BMenuItem *		menuitem_view_cheat;
	BMenuItem *		menuitem_view_clear;

	BMenuItem *		menuitem_view_blur_little;
	BMenuItem *		menuitem_view_blur;
	BMenuItem *		menuitem_view_blur_more;

	BMenuItem *		menuitem_TV_monitoring;
	
	BMenu *			TV_menu;
};

#endif // _MOSAIC_WINDOW_H_
